/***************************************************************************/
/*                                                                         */
/*   TLCUTL.C                                                              */
/*                                                                         */
/*   Copyright (c) 1994-1995 GALACTICOMM, Inc.    All Rights Reserved.     */
/*                                                                         */
/*   Common utility routines between MJRTLC.C and CSMJRTLC.C.              */
/*                                                                         */
/*                                            - Bill Hyatt 10/4/94         */
/*                                                                         */
/***************************************************************************/

#include "tlc.h"

#define FILREV "$Revision:   1.0.1.2.1.0  $"

STATIC void fmtdpk();
STATIC void supcht(int unum,int onum);
STATIC void xitutl(int orgguy,int othguy,int hangup);

int
chncnt(void)                       /* count number of users on channel     */
{
     int cnt=0,ousn;
     unsigned chan;
     struct user *ousp;

     chan=tlclst[usrnum].channel;
     for (ousn=0,ousp=user ; ousn < nterms ; ousn++,ousp++) {
          if (ousp->flags&ISGCSU) {
               if (tlclst[ousn].flags&TLCGCS && tlclst[ousn].channel == chan) {
                    if (!(ousp->flags&INVISB) || ousn == usrnum) {
                         cnt++;
                    }
               }
          }
          else {
               if (ousp->state == tlcstt && ousp->substt == 1
                 && tlclst[ousn].channel == chan) {
                    if (!(ousp->flags&INVISB) || ousn == usrnum) {
                         cnt++;
                    }
               }
          }
     }
     return(cnt);
}

void
initls(void)                       /* initialize teleconferencer list      */
{
     othusn=-1;
     othusp=user-1;
     tptr=tlclst-1;
}

char *
tlsrui(                            /* teleconferencer list, get next one   */
int lsttyp)                        /*   type of list being built           */
{
     static char retval[UIDSIZ+6];
     BOOL incl=FALSE;

     while (othusn < nterms-1) {
          othusn++;
          othusp++;
          othuap=uacoff(othusn);
          tptr++;
          if (othusn != usrnum
           && !(othusp->flags&INVISB)
           && ((othusp->flags&ISGCSU && tptr->flags&TLCGCS)
            || (othusp->state == tlcstt && othusp->substt == 1))) {
               switch (lsttyp) {
               case LSTALL:
                    incl=TRUE;
                    break;
               case LSTSCH:
                    incl=tptr->channel == tlcptr->channel;
                    break;
               case LSTCS:
                    incl=(othusp->flags&ISGCSU) > 0;
                    break;
               case LSTCRQ:
                    incl=tptr->chatch == usrnum;
                    break;
               }
               if (incl) {
                    strcpy(retval,othuap->userid);
                    if (!(usrptr->flags&ISGCSU) && tptr->flags&SQUCHD) {
                         strcat(retval,"(sq)");
                    }
                    return(retval);
               }
          }
     }
     return(NULL);
}

BOOL
inscan(                            /* should user be in tele scan?         */
int unum,                          /*   user num in question               */
struct tlc *tp)                    /*   tele info for user                 */
{
     if (user[unum].flags&ISGCSU && tp->flags&(TLCGCS|TLCCHT)) {
          return(!(user[unum].flags&INVISB));
     }
     if (!(user[unum].flags&ISGCSU) && user[unum].state == tlcstt) {
          return(!(user[unum].flags&INVISB));
     }
     return(FALSE);
}

char *
scnchn(                            /* what to disp for chan in tele scan   */
int unum,                          /*   user num in ques                   */
struct tlc *tp)                    /*   tele info for user                 */
{
     if ((user[unum].flags&ISGCSU && tp->flags&TLCCHT)
      || (!(user[unum].flags&ISGCSU) && user[unum].substt == 2)) {
          return("(Chat)");
     }
     if (tp->flags&SHWCHN || usrptr->flags&MASTER
      || tp->channel == 0 || fidxst(tp->channel)
      || (!(tp->flags&LUISSU) && tp->modchn == tp->channel)) {
          if (usrptr->flags&ISGCSU) {
               return(spr("%u",tp->channel+1));
          }
          else {
               return(spr("%5u",tp->channel+1));
          }
     }
     return("(Unlisted)");
}

char *
scntpc(                            /* what to disp for topic in tele scan  */
struct tlc *tp)                    /*   tele info for user                 */
{
     char *stp;

     if ((stp=getftpc(tp->channel)) != NULL) {
          return(spr("%s",stp));
     }
     if (tp->channel == tp->modchn) {
          return(tp->topic);
     }
     return(NULL);
}

int
urinv(void)                        /* can't execute command while invisible*/
{
     if (usrptr->flags&INVISB) {
          if (usrptr->flags&ISGCSU) {
               prf("INV");
          }
          prfmsg(URINVS);
          return(TRUE);
     }
     return(FALSE);
}

int
howmny(                            /* number of people starting w/ stg?    */
char *stg,                              /* stg to use in sameto() test     */
int prec,                               /* how precise should this be? 0-2 */
BOOL samas)                             /* take sameas() as a return(1)?   */
{
     int cnt=0,dstusn;

     for (othusn=0,othusp=user ; othusn < nterms ; othusn++,othusp++) {
          othuap=uacoff(othusn);
          switch (prec) {
          case 2:
               if (tlclst[othusn].channel != tlclst[usrnum].channel) {
                    break;
               }
          case 1:
               if (!((othusp->flags&ISGCSU && tlclst[othusn].flags&TLCGCS)
                     || (othusp->state == tlcstt && othusp->substt == 1))) {
                    break;
               }
          case 0:
               if (othusp->flags&INVISB || othusp->class < SUPLON
                 || !sameto(stg,othuap->userid)) {
                    break;
               }
               if (samas && sameas(stg,othuap->userid)) {
                    return(1);
               }
               dstusn=othusn;
               cnt++;
          }
     }
     if (cnt == 1) {
          othusn=dstusn;
          othusp=&user[othusn];
          othuap=uacoff(othusn);
     }
     return(cnt);
}

int
ck4mod(                            /* check for a channel moderator        */
int excusr)                        /*   user to exclude from search        */
{
     for (tptr=tlclst,othusn=0 ; othusn < nterms ; tptr++,othusn++) {
          if (tptr->modchn == tlcptr->channel && othusn != excusr) {
               if (tptr->modchn != 0) {
                    return(1);
               }
          }
     }
     return(0);
}

BOOL
xfrmod(                            /* transfer of channel moderatorship    */
char *uid)                         /*   user to transfer to                */
{
     struct tlc *otptr;
     BOOL iscs;

     if (urinv()) {
          return(FALSE);
     }
     iscs=(usrptr->flags&ISGCSU) != 0;
     if (tlcptr->channel != tlcptr->modchn || tlcptr->modchn == 0) {
          if (iscs) {
               prf("NMD");
          }
          prfmsg(NOTMOD,(ck4mod(usrnum) ? uacoff(othusn)->userid : "nobody"));
          return(FALSE);
     }
     if (uid == NULL) {
          tlcptr->modchn=0;
          outtlc(ENDCON,ALLU,usrnum,-1,usaptr->userid);
          if (iscs) {
               prf("RES");
          }
          prfmsg(RESIGN);
          return(TRUE);
     }
     if (!onsys(uid) || !(((othusp->flags&ISGCSU
         && tlclst[othusn].flags&TLCGCS)
        || (othusp->state == tlcstt && othusp->substt == 1))
       && tlclst[othusn].channel == tlcptr->channel)) {
          if (iscs) {
               prf("NHR");
          }
          prfmsg(WHSNHR,uid);
          return(FALSE);
     }
     otptr=&tlclst[othusn];
     if (otptr->modchn != 0) {
          if (iscs) {
               prf("ALM");
          }
          prfmsg(ALRMOD,otptr->modchn+1);
          return(FALSE);
     }
     otptr->flags&=~SQUCHD;
     otptr->modchn=otptr->channel;
     strcpy(otptr->topic,tlcptr->topic);
     tlcptr->modchn=0;
     if (othusp->flags&ISGCSU) {
          cnvd2s(spr("sa=%s;u=%s;:ubmodr",TLCAID,othuap->userid),namtmp);
          if (qroom(othusn,NORMAL)) {
               senddpk(othusn,TLCAID,NORMAL,namtmp,STGLEN,usaptr->userid);
          }
     }
     else {
          prfmlt(UBMODR,usaptr->userid);
          prfmlt(TLCPMT);
          outmlt(othusn);
     }
     outtlc(NEWMOD,ALLU,usrnum,othusn,usaptr->userid,othuap->userid);
     if (iscs) {
          prf("RES");
     }
     prfmsg(RESIGN);
     return(TRUE);
}

void
ntfyres(                           /* notify former chan of modrtr resign  */
unsigned excchn)                   /*    channel to exclude                */
{
     unsigned savchn;

     if (tlcptr->modchn != 0 && tlcptr->modchn != excchn) {
          savchn=tlcptr->channel;
          tlcptr->channel=tlcptr->modchn;
          outtlc(ENDCON,ALLU,usrnum,-1,usaptr->userid);
          tlcptr->channel=savchn;
     }
}

BOOL
squsqu(                            /* squelch/unsquelch user utility       */
char *uid,                         /*   user to squelch/unsquelch          */
BOOL squel)                        /*   TRUE=squelch  FALSE=unsquelch      */
{
     int indx;
     long cbit;
     BOOL iscs;

     iscs=(usrptr->flags&ISGCSU) != 0;
     if (!onsys(uid)) {
          if (iscs) {
               prf("NHR");
          }
          prfmsg(WHSNHR,uid);
          return(FALSE);
     }
     if ((tlcptr->modchn == 0 || tlcptr->channel != tlcptr->modchn)
      && !(usrptr->flags&MASTER)) {
          if (iscs) {
               prf("NMD");
          }
          prfmsg(NOTMOD,(ck4mod(usrnum) ? uacoff(othusn)->userid : "nobody"));
          return(FALSE);
     }
     if (!(((othusp->flags&ISGCSU && tlclst[othusn].flags&TLCGCS)
         || (othusp->state == tlcstt && othusp->substt == 1))
        && tlclst[othusn].channel == tlcptr->channel)) {
          if (iscs) {
               prf("NHR");
          }
          prfmsg(WHSNHR,uid);
          return(FALSE);
     }
     indx=othusn/32;
     cbit=1L<<(othusn&0x1F);
     if (squel) {
          tlcptr->sqlflg[indx]|=cbit;
          tlclst[othusn].flags|=SQUCHD;
          if (othusp->flags&ISGCSU) {
               cnvd2s(spr("sa=%s;u=%s;:yousqu",TLCAID,othuap->userid),namtmp);
               if (qroom(othusn,NORMAL)) {
                    senddpk(othusn,TLCAID,NORMAL,namtmp,0,NULL);
               }
          }
          else {
               prfmlt(YOUSQU);
               prfmlt(TLCPMT);
               outmlt(othusn);
          }
          outtlc(CHIMSQ,ALLU,usrnum,othusn,othuap->userid);
          if (iscs) {
               prf("HSQ");
          }
          prfmsg(HESSQU,othuap->userid);
     }
     else {
          tlcptr->sqlflg[indx]&=~cbit;
          tlclst[othusn].flags&=~SQUCHD;
          if (othusp->flags&ISGCSU) {
               cnvd2s(spr("sa=%s;u=%s;:youusq",TLCAID,othuap->userid),namtmp);
               if (qroom(othusn,NORMAL)) {
                    senddpk(othusn,TLCAID,NORMAL,namtmp,0,NULL);
               }
          }
          else {
               prfmlt(YOUUSQ);
               prfmlt(TLCPMT);
               outmlt(othusn);
          }
          outtlc(CHEUSQ,ALLU,usrnum,othusn,othuap->userid,flgbyt(othusn));
          if (iscs) {
               prf("USQ");
          }
          prfmsg(HESUSQ,othuap->userid);
     }
     return(TRUE);
}

int
chkchn(                            /* check if ok to switch to new chan    */
long newchn)                       /*   tele channel to switch to          */
{
     if (newchn < 1L || newchn > 65535L) {
          return(OUTORG);
     }
     if (newchn == tlcptr->channel+1) {
          return(YOURCH);
     }
     if (!(usrptr->flags&ISGCSU)
      && fidxst(tlcptr->channel) && !swtfrm
      && !(usrptr->flags&MASTER)) {
          return(CANTLV);
     }
     if (fidxst((unsigned)newchn-1)
      && ((usrptr->flags&ISGCSU && !cswto)
          || (!(usrptr->flags&ISGCSU) && !swtfrm))
      && !(usrptr->flags&MASTER)) {
          return(CANTGO);
     }
     if (fidxst((unsigned)newchn-1) && !faccok((unsigned)newchn-1)
      && !(usrptr->flags&MASTER)) {
          return(PRVLCH);
     }
     if (newchn > maxfre && !haskey(unlkey)) {
          return(PAYONL);
     }
     if (tlcptr->swchan++ >= nswchx) {
          return(NANNOY);
     }
     return(CHANOK);
}

void
swtchn(                            /* switch user to new tele channel      */
long newchn)                       /*   channel to switch to               */
{
     if (!(usrptr->flags&INVISB)) {
          outtlc(LEFTCH,ALLU,usrnum,-1,usaptr->userid);
     }
     tlcptr->flags&=~SQUCHD;
     tlcptr->channel=(unsigned)newchn-1;
     for (tptr=tlclst,othusn=0 ; othusn < nterms ; tptr++,othusn++) {
          if (tptr->modchn != 0 && tptr->modchn == tlcptr->channel
           &&(tptr->SQLFLS(usrnum)&SQLBIT(usrnum))) {
               tlclst[usrnum].flags|=SQUCHD;
          }
     }
     if (!(usrptr->flags&INVISB)) {
          outtlc(CAMEIN,ALLU,usrnum,-1,usaptr->userid,flgbyt(usrnum));
     }
}

void
sndwsp(                            /* send whispered msg utility           */
char *what)                        /*   message to send                    */
{
     char datbuf[TDBFSZ];

     if (othusp->flags&ISGCSU) {
          if (qroom(othusn,NORMAL)) {
               cnvd2s(spr("sa=%s;u=%s;:whisper",TLCAID,othuap->userid),namtmp);
               stlcpy(datbuf,spr("%s\t",usaptr->userid),UIDSIZ);
               strcat(datbuf,what);
               senddpk(othusn,TLCAID,NORMAL,namtmp,STGLEN,datbuf);
          }
     }
     else {
          prfmlt(WHSTO,usaptr->userid,what);
          prfmlt(TLCPMT);
          outmlt(othusn);
     }
     if (!(usrptr->flags&ISGCSU)) {
          prfmsg(WHSSNT,othuap->userid);
     }
}

int
chkcht(                            /* check if a chat request is ok        */
char *uid)                         /*   userid to chat with                */
{
     int count;

     if (urinv()) {
          return(URINVS);
     }
     if (uid[0] == '\0') {
          return(CHAFMT);
     }
     if ((count=howmny(uid,1,1)) == 0) {
          return(WHSNHR);
     }
     if (count != 1) {
          return(AMBIG);
     }
     if (othusn == usrnum) {
          return(NCHSLF);
     }
     if (usrptr->flags&ISGCSU && !(othusp->flags&ISGCSU)) {
          return(NOCHAA);
     }
     if (!(usrptr->flags&ISGCSU) && othusp->flags&ISGCSU) {
          return(NOCHCS);
     }
     if ((tlclst[othusn].flags&CCHVLD) && usrnum == tlclst[othusn].chatch) {
          return(ENTCHA);
     }
     if (tlclst[othusn].flags&NOPAGE) {
          return(PAGOFF);
     }
     if (!(tlclst[othusn].flags&OKPAGE) && tlclst[othusn].reqcha) {
          return(CHAL2M);
     }
     return(CHAREQ);
}

void
reqcht(void)                       /* send chat request to othusn          */
{
     BOOL reqok;

     if (othusp->flags&ISGCSU) {
          cnvd2s(spr("sa=%s;u=%s;:chtreq",TLCAID,othuap->userid),namtmp);
          senddpk(othusn,TLCAID,NORMAL,namtmp,STGLEN,
                  spr("%s%c",usaptr->userid,tlcsex(usaptr->sex)));
          reqok=TRUE;
     }
     else {
          prfmlt(CHAREQ,usaptr->userid,tlcsxp(usaptr->sex),usaptr->userid);
          reqok=injoth();
     }
     if (reqok) {
          rmvcht(othusn);
          tlcptr->chatch=othusn;
          tlcptr->flags|=CCHVLD;
          tlclst[othusn].reqcha=(reqint+7)/15;
          if (usrptr->flags&ISGCSU) {
               prf("REQ");
          }
          else {
               prfmsg(CREQOK,othuap->userid);
          }
     }
     else {
          if (usrptr->flags&ISGCSU) {
               prf("NPS");
          }
          prfmsg(PAGNPS,othuap->userid);
     }
}

void
rmvcht(                            /* rem cur user fm tlcptr->chatch's list*/
int excusr)                        /*   don't remove from this user's list */
{
     if (tlcptr->flags&CCHVLD
      && tlcptr->chatch != excusr && user[tlcptr->chatch].flags&ISGCSU) {
          cnvd2s(spr("sa=%s;u=%s;:unchtreq",TLCAID,
                     uacoff(tlcptr->chatch)->userid),namtmp);
          senddpk(tlcptr->chatch,TLCAID,NORMAL,namtmp,STGLEN,
                    usaptr->userid);
     }
}

void
entcht(void)                       /* enter usrnum and othusn into chat    */
{
     rmvcht(othusn);
     tlcptr->chatch=othusn;
     supcht(usrnum,othusn);
     supcht(othusn,usrnum);
     if (othusp->flags&ISGCSU) {
          cnvd2s(spr("sa=%s;u=%s;:entcht",TLCAID,othuap->userid),namtmp);
          senddpk(othusn,TLCAID,NORMAL,namtmp,STGLEN,usaptr->userid);
     }
     else {
          prfmlt(ACCPCH,usaptr->userid);
          prfmlt(ENTCHA);
          outmlt(othusn);
          btuchi(othusn,tlchat);
     }
     if (usrptr->flags&ISGCSU) {
          prf("ENT");
     }
     else {
          prfmsg(ENTCHA);
          btuchi(usrnum,tlchat);
     }
}

STATIC void
supcht(                            /* setup for chat                       */
int unum,                          /*   user entering chat                 */
int onum)                          /*   user he's chatting with            */
{
     struct usracc *uaptr;
     struct user *uptr;

     uaptr=uacoff(unum);
     uptr=&user[unum];
     if (user[unum].flags&ISGCSU) {
          tlclst[unum].flags&=~TLCGCS;
          tlclst[unum].flags|=TLCCHT;
          outtlc(GONCHA,ALLU,onum,-1,uaptr->userid);
     }
     else {
          tlclst[unum].flags&=~TYPING;
          btumil(unum,-(uaptr->scnwid-1));
          uptr->substt=2;
          uptr->flags|=NOGLOB;
          outtlc(GONCHA,ALLU,onum,-1,uaptr->userid);
          btucli(unum);
          btuclo(unum);
     }
}

void
xitcht(                            /* remove users from chat               */
BOOL hangup)                       /*   got a hangup?                      */
{
     int org;

     xitutl(usrnum,FALSE,hangup);
     org=usrnum;
     curusr(tlcptr->chatch);
     tlcptr=&tlclst[usrnum];
     xitutl(org,TRUE,hangup);
     curusr(org);
     tlcptr=&tlclst[usrnum];
}

STATIC void
xitutl(                            /* utility to remove users from chat    */
int orgguy,                        /*   usrnum that originally exited      */
BOOL othguy,                       /*   handling guy that got exited on?   */
BOOL hangup)                       /*   did user that exited hang up?      */
{
     if (usrptr->flags&ISGCSU) {
          if (hangup && !othguy) {
               return;
          }
          if (!othguy) {
               if (tlcptr->flags&TLCGCS) {
                    outtlc(ENTTLC,ALLU,usrnum,-1,usaptr->userid,
                           tlcptr->flags&DBRDUP ? "Y" : "N");
               }
          }
          else {
               tlcptr->flags|=TLCGCS;
               cnvd2s(spr("sa=%s;u=%s;:xitcht",TLCAID,usaptr->userid),namtmp);
               senddpk(usrnum,TLCAID,NORMAL,namtmp,STGLEN,
                       hangup ? "HUP" : "XIT");
               outtlc(ENTTLC,ALLU,usrnum,-1,usaptr->userid,
                      tlcptr->flags&DBRDUP ? "Y" : "N");
          }
          tlcptr->reqcha=0;
          tlcptr->flags&=~(TLCCHT|CCHVLD);
     }
     else {
          btuchi(usrnum,NULL);
          if (hangup && !othguy) {
               return;
          }
          tlcptr->flags&=~CCHVLD;
          tlcptr->reqcha=0;
          btucli(usrnum);
          btumil(usrnum,tinpsz);
          outtlc(ENTTLC,ALLU,usrnum,-1,usaptr->userid," ");
          usrptr->substt=1;
          usrptr->flags&=~NOGLOB;
          prfmsg((hangup ? OCHHP2 : EXICH2),uacoff(orgguy)->userid);
          if (hangup || !othguy || (othguy && user[orgguy].flags&OPCHAT)) {
               tlcctx();
          }
          prfmsg(TLCPMT);
          outprf(usrnum);
          clrprf();
     }
}

void
tlchup(void)                       /* common C/S / A/A tele hangup routine */
{
     int i;

     setmbk(tlcmb);
     tlcptr=&tlclst[usrnum];
     ntfyres(0);
     if (usrptr->state == tlcstt) {
          if (usrptr->substt == 2) {
               xitcht(1);
          }
          else {
               if (!(usrptr->flags&INVISB)) {
                    outtlc(TLCHUP,ALLU,usrnum,-1,usaptr->userid);
               }
          }
          rmvcht(-1);
     }
     else if (tlcptr->flags&TLCGCS) {
          if (!(usrptr->flags&INVISB)) {
               outtlc(TLCHUP,ALLU,usrnum,-1,usaptr->userid);
          }
          rmvcht(-1);
     }
     else if (tlcptr->flags&TLCCHT) {
          xitcht(1);
     }
     for (tptr=tlclst,i=0 ; i < nterms ; tptr++,i++) {
          if (tptr->chatch == usrnum) {
               tptr->flags&=~CCHVLD;
          }
          tptr->SQLFLS(usrnum)&=~SQLBIT(usrnum);
     }
     abosnd();
     aboarcvs();
     setmem(tlcptr,sizeof(struct tlc),0);
}

char *
flgbyt(                            /* flag byte indicater for user lists   */
int unum)                          /*   user number in question            */
{
     char *fbyt;

     if (tlclst[unum].flags&SQUCHD) {
          fbyt="S";
     }
     else if (user[unum].flags&ISGCSU) {
          fbyt=(tlclst[unum].flags&DBRDUP) ? "Y" : "N";
     }
     else {
          fbyt=" ";
     }
     return(fbyt);
}

int
ck4pfn(void)                       /* check for profanity and deal with it */
{
     if (usrptr->pfnacc > MAXPFN) {
          byenow(NOMSG);
          return(HUNGUP);
     }
     if (pfnlvl >= 2 && usrptr->pfnacc > WRNPFN) {
          if (usrptr->flags&ISGCSU) {
               prf("PFN");
          }
          prfmsg(RAUNCH);
          return(WARNED);
     }
     if (pfnlvl > 2) {
          if (usrptr->flags&ISGCSU) {
               prf("PFN");
          }
          prfmsg(PFNWRD);
          return(WARNED);
     }
     return(NOPFN);
}

void
outtlc(                            /* send output to tele chans            */
int msg,                           /*   msg block being used for A/A users */
int sendto,                        /*   send to C/S, A/A, or both?         */
int orgusr,                        /*   user num output is originating from*/
int excusr,                        /*   user to exclude from sending       */
char *parm1,                       /*   variable parameters (as in spr())  */
char *parm2,
char *parm3)
{
     int ousn;
     struct user *ousp;
     char datbuf[TDBFSZ];

     if (sendto == CS || sendto == ALLU) {
          stzcpy(namtmp->sysid,msysid,SIDSIZ);
          stzcpy(namtmp->appid,TLCAID,AIDSIZ);
          namtmp->flags=0x00;
          fmtdpk(msg,namtmp->suffix,datbuf,parm1,parm2,parm3);
     }
     if (sendto == AA || sendto == ALLU) {
          setmbk(tlcmb);
          prfmlt(msg,parm1,parm2,parm3);
          prfmlt(TLCPMT);
     }
     for (ousn=0,ousp=user ; ousn < nterms ; ousn++,ousp++) {
          if (ousn != orgusr && ousn != excusr) {
               if (ousp->flags&ISGCSU) {
                    if (tlclst[ousn].flags&TLCGCS
                     && (sendto == CS || sendto == ALLU)
                     && tlclst[orgusr].channel == tlclst[ousn].channel
                     && qroom(ousn,NORMAL)) {
                         stzcpy(namtmp->usrid,uacoff(ousn)->userid,UIDSIZ);
                         senddpk(ousn,TLCAID,NORMAL,namtmp,STGLEN,datbuf);
                    }
               }
               else {
                    if (ousp->state == tlcstt && ousp->substt == 1
                     && (sendto == AA || sendto == ALLU)
                     && tlclst[orgusr].channel == tlclst[ousn].channel) {
                         outmlt(ousn);
                    }
               }
          }
     }
     clrmlt();
}

STATIC void
fmtdpk(                            /* format dpk info for C/S users        */
int typ,                           /*   ind's what type of info            */
char *dpksfx,                      /*   dpk suffix for dpk structure       */
char *datbuf,                      /*   where to put formatted info        */
char *parm1,                       /*   variable parameters                */
char *parm2,
char *parm3)
{
     parm3=parm3;
     datbuf[0]='\0';
     switch (typ) {
     case ENTTLC:
          stzcpy(dpksfx,"enttlc",SFXSIZ);
          stzcpy(datbuf,spr("%s%s",parm1,parm2),UIDSIZ+1);
          break;
     case NMTALK:
          stzcpy(dpksfx,"nmtalk",SFXSIZ);
          stzcpy(datbuf,spr("%s\t",parm1),UIDSIZ+1);
          strcat(datbuf,parm2);
          break;
     case DBRDUP:
          stzcpy(dpksfx,"dbrdup",SFXSIZ);
          stzcpy(datbuf,spr("%s%s",parm1,parm2),UIDSIZ+1);
          break;
     case DBRDDN:
          stzcpy(dpksfx,"dbrddn",SFXSIZ);
          stzcpy(datbuf,spr("%s%s",parm1,parm2),UIDSIZ+1);
          break;
     case CAMEIN:
          stzcpy(dpksfx,"camein",SFXSIZ);
          stzcpy(datbuf,spr("%s%s",parm1,parm2),UIDSIZ+1);
          break;
     case LEFTCH:
          stzcpy(dpksfx,"leftch",SFXSIZ);
          stzcpy(datbuf,parm1,UIDSIZ);
          break;
     case GONCHA:
          stlcpy(dpksfx,"goncha",SFXSIZ);
          stlcpy(datbuf,parm1,UIDSIZ);
          break;
     case BGNCON:
          stlcpy(dpksfx,"bgncon",SFXSIZ);
          stlcpy(datbuf,spr("%s\t%s",parm1,parm2),UIDSIZ+CTPSIZ);
          break;
     case NEWMOD:
          stlcpy(dpksfx,"newmod",SFXSIZ);
          stlcpy(datbuf,spr("%s\t%s",parm1,parm2),UIDSIZ+UIDSIZ);
          break;
     case ENDCON:
          stlcpy(dpksfx,"endcon",SFXSIZ);
          stlcpy(datbuf,parm1,UIDSIZ);
          break;
     case CHIMSQ:
          stlcpy(dpksfx,"chimsq",SFXSIZ);
          stlcpy(datbuf,parm1,UIDSIZ);
          break;
     case CHEUSQ:
          stlcpy(dpksfx,"cheusq",SFXSIZ);
          stlcpy(datbuf,spr("%s%s",parm1,parm2),UIDSIZ+1);
          break;
     case LVITLC:
          stzcpy(dpksfx,"lvitlc",SFXSIZ);
          stzcpy(datbuf,parm1,UIDSIZ);
          break;
     case TLCHUP:
          stlcpy(dpksfx,"tlchup",SFXSIZ);
          stlcpy(datbuf,parm1,UIDSIZ);
          break;
     default:
          catastro("FMTDPK: invalid value type parameter! (%d)",typ);
     }

}

